/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */
/* lirc interface */
#ifndef __GIR_LIRC_H__
#define __GIR_LIRC_H__

#include <glib-object.h>

#define GIR_TYPE_LIRC			(gir_lirc_get_type ())
#define GIR_LIRC(obj)			(G_TYPE_CHECK_INSTANCE_CAST ((obj), GIR_TYPE_LIRC, GirLirc))
#define GIR_LIRC_CLASS(klass)		(G_TYPE_CHECK_CLASS_CAST ((klass), GIR_TYPE_LIRC, GirLircClass))
#define GIR_IS_LIRC(obj)		(G_TYPE_CHECK_INSTANCE_TYPE ((obj), GIR_TYPE_LIRC))
#define GIR_IS_LIRC_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), GIR_TYPE_LIRC))

typedef struct _GirLirc GirLirc;
typedef struct _GirLircClass GirLircClass;

struct _GirLirc
{
	GObject parent;
};

struct _GirLircClass
{
	GObjectClass parent_class;

	void (*recv_ir)	     (GirLirc *lirc, int repeat_count,
			      const char *button, const char *control);
	void (*disconnected) (GirLirc *lirc, GError **error);
};


GType		gir_lirc_get_type	(void) G_GNUC_CONST;
GirLirc*	gir_lirc_new		(void);


char*	gir_lirc_get_lirc_version	(GirLirc *lirc);
GList*	gir_lirc_get_button_list	(GirLirc *lirc, const char *control);
GList*	gir_lirc_get_control_list	(GirLirc *lirc);

gboolean	gir_lirc_is_connected	(GirLirc *lirc);
gboolean	gir_lirc_connect	(GirLirc *lirc, GError **error);
void		gir_lirc_disconnect	(GirLirc *lirc);

#endif /* __GIR_LIRC_H__ */
