/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */
#ifndef _GIR_MAPPINGS_H_
#define _GIR_MAPPINGS_H_

#include <glib.h>
#include <gtk/gtktreemodel.h>

typedef struct _GirMappings GirMappings;

typedef enum {
	GIR_ACTION_NONE,
	GIR_ACTION_KEY,		/* forward as a key press/release */
} GirActionType;

typedef struct {
	GirActionType type;
	char *data1;
	char *data2;
} GirAction;

GirMappings*	gir_mappings_new	(void);
void		gir_mappings_free	(GirMappings *mappings);

gboolean	gir_mappings_load_xml	(GirMappings *mappings,
					 const char *xml);
char*		gir_mappings_dump_xml	(GirMappings *mappings);


void	gir_mappings_do_action  (GirMappings *mappings,
				 const char *control,
				 const char *button,
				 int repeat);

const GirAction*	gir_mappings_get_action  (GirMappings *mappings,
						  const char *control,
						  const char *button);

void	gir_mappings_set_action  	 (GirMappings *mappings,
				 	  const char *control,
				 	  const char *button,
				 	  const GirAction *action);
void	gir_mappings_set_action_default  (GirMappings *mappings,
					  const char *control,
					  const char *button);


GtkTreeModel*	gir_mappings_get_tree_model (GirMappings *mappings);

void		gir_mappings_sync (GirMappings *mappings);

#endif /* _GIR_MAPPINGS_H_ */
